多数情况下无区别,上面的脚本设计成了如下几

2019-11-01 11:02 来源:未知

什么是shell?

shell是一个命令解释器,它在操作系统的最外层,负责直接与用户对话,把用户的输入解释给操作系统,并处理各种各样的操作系统的输出结果,输出到屏幕返回给用户。这种对话方式可以是交互的方式(从键盘输入命令,可以立即得到shell的回应),或非交互(执行脚本程序)的方式。
下图的黄色部分就是命令解释器shell处于的操作系统中位置形象图解。
永利平台娱乐 1

 

前言

学习shell脚本编程需要的知识储备:

vi/vim编辑器命令 vimrc设置要熟练

基础命令,100多个要熟练

基础和常用的网络服务命令要会:nfs 、 rsync、 inotify 、 lanmp 、 sersync  、ssh  key

永利平台娱乐 2

一、Shell脚本

什么是shell脚本?

当linux命令或语句不在命令下执行(严格说,命令行执行的语句也是shell脚本),而是通过一个程序文件执行时,该程序就被称为shell脚本或shell程序,shell程序很类似DOS系统下的批处理程序(扩展名*.bat)。用户可以在shell脚本中敲入一系列的命令或命令语句组合。这些命令、变量和流程控制语句等有机的结合起来就形成了一个功能很强大的shell脚本。
下面是在windows下利用批处理程序bat开发的备份网站及数据库数据的脚本。
@echo off
set date=%date:`0,4%-%date:`5,2%-%date:`8,2%
mysqldump -uroot -poldboy -A -B > D:bak"%date%".sql
rar.exe a -k -r -s -ml D:bak"%date%".sql.rar D:bak"%date%".sql
del D:bak*.sql
rar.exe a -k -r -s -ml D:bak"%date%"htdocs.rar D:workhtdocs
示例1:清除/var/log下messages日志文件的简单命令脚本。
#把所有命令放在一个文件里堆积起来就形成了脚本,下面是一个最简单的命令堆积形成的shell脚本
#root身份运行
#清楚日志
cd /var/log
cat /dev/null > messages
echo "Logs cleaned up."
上述脚本存在如下问题:
1、如果不是root用户无法执行清理日志。
2、无流程控制语句,没有判断和逻辑。
示例2:包含命令、变量和流程控制语句的清除/var/log下messages日志文件的shell脚本。
#!/bin/bash
#清除日志脚本
LOG_DIR=/var/log
ROOT_UID=0 #$UID为0的时候,用户才具有root用户的权限
#使用root运行
if [ "$UID" -ne "$ROOT_UID" ]
then
echo "Mast be root to run this script."
exit 1
fi
cd $LOG_DIR || {
echo "Cannot change to necessary directory." >&2
exit 1 
}
cat /dev/null > messages && echo "Logs cleaned up."
exit 0
#退出之前返回0表示成功,返回1表示失败。
拓展:清空日志及文件内容的三种方法。
[root@lamp ~]# echo >test.log
[root@lamp ~]# >test.log 
[root@lamp ~]# cat /dev/null > test.log 

一、shell脚本概念及示例

一、shell脚本

1.Shell脚本的建立

由Linux命令、shell命令、程序结构控制语句和注释等内容组成。

脚本第一行

#!/bin/bash
#!字符称为幻数,内核会根据它后面的解释器来确定该用什么程序解释脚本

bash与sh的区别
sh为bash的软连接,多数情况下无区别

[xiaoda@codis-178 ~]$ ll /bin/sh
lrwxrwxrwx. 1 root root 4 Mar  4  2016 /bin/sh -> bash
[xiaoda@codis-178 ~]$ ll /bin/bash
-rwxr-xr-x. 1 root root 1009968 Nov 17  2014 /bin/bash

检查bash是否有漏洞

[root@codis-178 ~]# env x='() { :;}; echo be careful' bash -c "echo this is a test"
this is a test

如果返回以下两行,则尽快升级
be careful
this is a test

若不指定解释器,则用对应解释器执行脚本
bash test.sh
python test.py
expect test.exp

shell脚本在运维工作中的地位

shell脚本很擅长处理纯文本类型的数据,而linux系统中几乎所有的配置文件(如nfs、rsync、httpd、nginx、lvs等)、多数启动文件都是纯文本类型的文件。因此利用shell可以在linux系统中发挥巨大作用。

1、什么是shell

Shell是一个命令解释器,它在操作吸引的最外层,负责直接与用户对话,把用户的输入解释给操作系统,并处理各种各样的操作系统的输出结果,输出到屏幕返回给用户。这种对话方式可以是交互的方式(从键盘输入命令立即得到Shell的回应),或非交互(脚本)的方式。

当命令或程序语句不在命令行下执行,而是通过一个程序文件来执行时,该程序就被称为shell脚本。

2.脚本注释

解释器看不到,不会执行
可跟在脚本命令的后面,与命令在同一行
尽量不要用中文

shell脚本语言的种类

在UNIX/LINUX中主要有两大类shell。
Bourne shell包括sh、ksh和bash。
Bourne shell (sh)
Korn shell (ksh)
Bourne Again shell (bash)
POSIX shll (sh)
C shell包括csh和tcsh。
C shell (csh)
TEXES/TOPS C shell(tcsh)
shell脚本语言是若类型语言,较为通用的shell有标准的Bourne shell(sh)和C shell(csh)。其中Bource shell(sh)已经被bash shell取代。
查看系统的shell。
[root@lamp ~]# cat /etc/shells
/bin/sh
/bin/bash #功能更强大
/sbin/nologin
/bin/dash
/bin/tcsh
/bin/csh

2、什么是Shell脚本

当命令或语句不在命令行执行,而是通过一个程序文件执行时,该程序就被称为Shell脚本或Shell程序,Shell程序很类似DOS系统下的批处理程序(*.bat)。用户可以在shell脚本中敲入一系列的命令或命令语句、这些命令、变量和流程控制语句等有机的结合起来就形成了一个功能强大的shell脚本。

windows下利用批处理程序bat开发的备份网站及数据库的脚本。

@echo off

set date=%date:~0,4%-%date:~5,2%-%date:~8,2%

mysqldump -uroot -poldboy -A -B > D:bak"%date%".sql

rar.exe a -k -r -s -ml D:bak"%date%".sql.rar D:bak"%date%".sql

del D:bak*.sql

rar.exe a -k -r -s -ml D:bak"%date%"htdocs.rar D:workPHPnowhtdocs

范例一、清除/var/log下message日志文件的简单命令文件

1 #把所有命令放在一个文件里堆积起来就形成了脚本,下面是一个简单的命令形成的shell脚本
2 #要使用root身份来运行这个脚本
3 清除日志脚本,版本1
4 cd /var/log
5 cat /dev/null > messages
6 echo "Logs cleaned up."
7 提示:/var/log/messages是系统的日志文件,很重要

缺点:

1)不是root用户执行不了

2)没有流程控制,没有逻辑性。

范例二、包括命令、变量和流程控制语句的清除/var/log 下message日志的脚本

 1 #!/bin/bash
 2 #清除日志脚本,版本2
 3 LOG_DIR=/var/log
 4 ROOT_UID=0 #$uid为0的时候,用户才具有root用户的权限
 5 #要使用root用户来运行
 6 if ["$UID" -ne "$ROOT_UID"]
 7 then
 8 echo "Must be root to run this script . "
 9 exit 1
10 fi
11 cd $LOG_DIR || { #如果cd没有执行成功就执行大括号中的内容
12 echo "Cannot change to nessarg directory " >&2
13 exit 1
14 }
15 cat /dev/null > messages
16 echo "Logs cleaned up"
17 exit 0
18 #退出之前0表示成功,返回1表示失败

清空日志的三种方法

1 echo >test.log #输入空的内容
2 >test.log
3 cat /dev/null > test.log #查看黑洞,将黑洞重定向到文件
4 应用:保留文件,清空内容

二、清除/var/log下messages日志文件的简单命令脚本

3.shell脚本的执行

永利平台娱乐 3
(1)查找系统环境变量ENV,该变量指定了环境文件,加载顺序/etc/profile ->.bash_profile->.bashrc->/etc/bashrc
(2)执行脚本
(3)自上而下,从左到右依次执行(脚本嵌套时,先执行自脚本)

常用操作系统的默认shell

Linux是bourne agaion shell(bash)。
Solaris和FreeBSD缺省的是Bourne shll(sh)。
AIX下是korn shell(ksh)。
HP-UX缺省的是POSIX shell(sh)。
查看CentOS默认shell。
第一种方法。
[root@lamp ~]# echo $SHELL
/bin/bash
[root@lamp ~]# echo $shell
bash
第二种方法。
[root@lamp ~]# grep root /etc/passwd
root:x:0:0:root:/root:/bin/bash
operator:x:11:0:operator:/root:/sbin/nologin
更改默认的shell配置文件。
[root@lamp ~]# cat /etc/default/useradd 
# useradd defaults file
GROUP=100
HOME=/home
INACTIVE=-1
EXPIRE=
SHELL=/bin/bash
SKEL=/etc/skel
CREATE_MAIL_SPOOL=yes

3、Shell程序在运维工作中的作用地位

Shell脚本很擅长处理纯文本类型的数据,而linux中几乎所有的配置文件、日志文件(如nfs 、rsync、httpd、nginx、lvs等)都是纯文本类型的文件,因此,如果学好Shell脚本语言,就可以利用它在Linux系统中发挥巨大的作用

下面是Shell脚本在运维工作中的作用地位形象图:

#!/bin/bash

4.执行脚本的方式

(1)bash script-name 或 sh script-name
(2)path/script-name 或 ./script-name
(3)source script-name 或 . script-name
(4)sh<script-name 或 cat script-name|sh

shell脚本的建立和执行

shell**脚本的建立。
在linux系统中,shell脚本(bash shll程序)通常是在编辑器(如vi/vim)中编写,由Unix/Linux命令、bash shell命令、程序结构控制语句和注释等内容组成,推荐使用vim编辑器编写,可以事先做一个别名alias vi='vim'。
[root@lamp ~]# echo "alias vi='vim'" >>/etc/profile
[root@lamp ~]# tail -n 1 /etc/profile
alias vi='vim'
[root@lamp ~]# source /etc/profile
[root@lamp ~]# . /etc/profile
脚本开头(第一行)
一个规范的shell脚本在脚本第一行会指出由哪个程序(解释器)来执行脚本中的内容,这一行内容在linux bash编程中一般为:
#! /bin/bash

#! /bin/sh <==255个字符以内
其中开头的"#!"字符又称为幻数,在执行bash脚本的时候,内核会根据"#!"后的解释器来确定该用哪个程序解释这个脚本的内容。注意,这一行必须在每个脚本顶端的第一行,如果不是第一行则为脚本注释行,例如下面的例子。
不加上诉第一行,默认就会使用linux默认的shell。
[root@lamp ~]# cat test.sh 
#!/bin/bash
echo "shell start"
#!/bin/bash #写到这里表示注释
#!/bin/sh
echo "shell end"
sh和bash的区别,早期的bash与sh稍有不同,它还包含了csh和ksh的特色,但大多数脚本都可以不加修改的在sh上运行。
[root@lamp ~]# ll /bin/sh
lrwxrwxrwx. 1 root root 4 Mar 10 2017 /bin/sh -> bash
[root@lamp ~]# ll /bin/bash 
-rwxr-xr-x. 1 root root 941944 Jan 12 2017 /bin/bash
sh为bash的软连接,推荐用标准写法#!/bin/bash。
注意,当使用/bin/sh执行脚本不正常的时候,可以使用/bin/bash执行。
bash**的版本
[root@lamp ~]# bash -version
GNU bash, version 4.1.2(2)-release (x86_64-redhat-linux-gnu)
Copyright (C) 2009 Free Software Foundation, Inc.
License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>

This is free software; you are free to change and redistribute it.
There is NO WARRANTY, to the extent permitted by law.
脚本注释
在shell脚本中,跟在(#)井号后面的内容表示注释,用来对脚本进行注释说明,注释部分不会被当做程序执行,仅仅是给用户看,系统解释器是看不到的,更不会执行。注释可自成一行,也可以跟在脚本命令后面与命令在同一行。开发脚本时,如果没有注释,团队里的其他人就很难理解脚本究竟在做什么,如果时间上了自己也会忘记。因此,我们要尽量养成为所开发的shell脚本书写注释的习惯。注释书写注意规范性,尽量不用中文。
shell**脚本的执行
当shell脚本运行时,它会先查找系统环境变量ENV,该变量指定了环境文件(通常是.bashrc、.bash_profile、/etc/bashrc、/etc/profile等),然后从该环境变量文件开始执行脚本,当读取了ENV的文件后,shell会开始执行shell脚本中的内容。
特殊技巧:设置crond任务时,最好把系统环境变量在定时任务脚本中重新定义,否则,一些系统环境变量将不会被加载。
shell脚本的执行通常可以采用以下几种方式:
1、bash script-name或sh script-name(推荐使用)。
2、path/script-name或./script-name(当前路径下执行脚本,需要脚本有执行权限)。
3、source script-name或. scripts-name("."点号)。
4、sh<script-name或cat script-name|sh(同样适合bash)。
执行说明
第一种方法是当脚本文件本身没有可执行权限(即文件x位为-号)时常使用的方法,或者文件开头没有指定解释器。
第二种方法需要先将脚本文件的权限改为可执行(即文件加X位),具体方法:chmod u+x script-name或chmod 755 script-name。然后通过脚本路径就可以直接执行脚本。
第三种放法通常是使用source或"."点号读入或加载指定的shell脚本文件(如test.sh),然后,依次执行指定shell脚本文件test.sh中的所有语句。
举例说明:
[root@lamp ~]# cat >test.sh
echo 'i am shell'
输入"echo 'i am shell'"内容后按回车,然后再按ctrl+d组合键即可结束编辑。
1)通过第一种方法执行
[root@lamp ~]# cat test.sh 
echo 'i am shell'
[root@lamp ~]# sh test.sh 
i am shell
[root@lamp ~]# bash test.sh 
i am shell
2)通过第二种方法执行
[root@lamp ~]# ll test.sh 
-rw-rw-r--. 1 root root 18 Jul 24 23:20 test.sh
[root@lamp ~]# ./test.sh #使用第二种方式,"./"在当前目录下执行test.sh脚本文件,无法使用tab自动补全
-bash: ./test.sh: Permission denied 
给test.sh添加可执行权限。
[root@lamp ~]# chmod u+x test.sh 
[root@lamp ~]# ./test.sh 
i am shell
3)通过第三种方法执行
[root@lamp ~]# . test.sh 
i am shell
[root@lamp ~]# source test.sh 
i am shell
4)通过第四种方法执行
[root@lamp ~]# sh <test.sh 
i am shell
[root@lamp ~]# cat test.sh|bash
i am shell
案例:已知如下命令及返回结果,请问echo $user的返回结果为()。
[root@lamp ~]# cat test.sh 
user=`whoami`
[root@lamp ~]# sh test.sh
[root@lamp ~]# echo $user
答案:空。
[root@lamp ~]# . test.sh 
[root@lamp ~]# echo $user
答案:root 
结论:1、子shell会直接继承父shell的变量、函数等。2、如果希望父shell调用子shell的变量、函数等,用source或"."点号执行脚本。
shell**脚本开发的基本习惯
1)脚本第一行指定脚本解析器。
#!/bin/sh或#!/bin/bash
2)脚本开头加版本版权等信息
#Date: 07:00 2018-07-26
#Mail:xxxxx@xxx
#Author:Created by golden
#Function:This scripts function is ...
#Version:1.3
提示:可以配置vim编辑文件时自动加上以上信息,方法是修改~/.vimrc配置文件。
3)脚本中不用中文注释
尽量用英文注释,防止本机或切换系统环境后中文乱码的困扰。
4)脚本以.sh为扩展名命名。
5)代码书写优秀习惯技巧
1、成对的符号内容尽量一次写出来,防止遗漏。
2、"[]"中括号两端要有空格,书写时即可留出空格[ ],然后在退格书写内容,先书写一对中括号,然后退一格,然后在输入两个空格,再退一格。 双中括号"[[]]"也是如此。
3、流程控制语句一次书写完,在添加内容。
if语句格式一次完成。
if 条件内容
then
内容
fi
for循环格式一次完成。
for
do
内容
done
6)通过缩进让代码更易读。

4、脚本语言的种类

1)shell脚本语言的种类

在unix/linux中主要有两大类shell

Bourse shell(sh ksh bash)

Bourne shell (sh)

Korn shell(ksh)

Bourne Again shell(bash)

POSIX shell (sh)

C shell(csh tcsh)

C shell (csh)

TENEX/TOPS C shell (tcsh)

Shell脚本语言是弱类型语言,较为通用的shell有标准的Bourne shell 和C shell。其中Bourne shell已经被bash shell取代。

2)Shell脚本与php,perl、python语言的差别?

shell的优势在于处理操作系统底层的业务。可以结合大量的linux命令和函数来执行。一键安装、报警脚本、常规的业务应用,shell开发更简单快速。

php,python优势在于开发运维工具,web界面的管理工具。

# 清除日志脚本

示例:

已知以下命令及返回结果,请问echo $user的返回结果是
cat test.sh
user='whoami'
sh test.sh
echo $user

a.当前用户
b.oldboy
c.无内容输出

答案是:c
解释:
sh和bash执行脚本会启动新的子shell,执行完后退回到父shell,因此变量或函数值无法保留。

5、常用操作系统的默认shell

linux/是Bourne Again shell(bash)

Solaris和FreeBSD缺省的是Bourse shell(sh)

AIX下是Korn Shell(ksh)

HP-UX缺省的是POSIX shell(sh)

Centos linux中的shell类型是(bash)

查看方式:1.echo $SHELL

2、grep root /etc/passwd

 二、建立规范的shell脚本

shell脚本的建立:

shell脚本通常是在编辑器(vi vim)中编写,由Unix/Linux命令、bash shell命令、程序结构控制语句和注释内容组成

脚本开头(第一行)

一个规范的shell脚本的第一行会指出程序(解析器)来执行脚本中的内容,在linux bash编程中一般为:

#!/bin/bash 或者#!/bin/sh

#!又称为幻数,在执行bash脚本的时候,内核会根据它来确定该用哪个程序来解释脚本中的内容,这一行必须在脚本顶端的第一行,如果不是第一行则为注释。

1 #!/bin/bash
2 
3 echo "test start"
4 
5 #!/bin/bash
6 
7 #!/bin/sh
8 
9 echo "test end"

以下为linux中常用脚本语言开头的编码写法,不同语言脚本的开头一般都要加上如下相应语言的标识内容:

  • #!/bin/sh
  • #永利平台娱乐,!/bin/bash
  • #!/usr/bin/awk
  • #!/bin/sed
  • #!/usr/bin/tcl
  • #!/usr/bin/expect
  • #!/usr/bin/perl
  • #!/usr/bin/env python

如果脚本抬头不指定解释器,那么,就要用对应的解释器来执行脚本,例如:bash test.sh

脚本注释

在shell脚本中,跟在(#)后面内容表示注释,用来对脚本进行注释说明,注释部分不会被执行,仅仅是给人看的,注释可自成一行,也可以跟在脚本命令后面与命令同在一行,开发脚本时,如果没有注释,其他人就很难理解脚本究竟在做什么,时间久了自己也会忘记。

shell脚本的执行:

当shell脚本以非交互的方式运行时,它会先查找环境变量ENV,该变量指定了一个环境变量(通常是.bashrc)然后从环境变量文件开始执行,当读取了ENV文件后,SHELL才开始执行shell脚本中内容。

 

LOG_DIR=/var/log

结论:

  • 子shell脚本会直接继承父shell脚本的变量、函数等,反之不可
  • 若想反过来继承,要用source 或 "." 在父shell中事先加载子shell

ROOT_UID=0 #<==$UID为0的用户,即root用户

二、变量

if [ "$UID" -ne "$ROOT_UID" ]

1.变量特性

shell中不区分变量的类型(整数、小数、字符串等)

then

2.变量类型

(1)环境变量(全局)
export内置命令导出的变量(用户名、路径、目录)
名字采用大写形式
set命令输出所有变量(全局和局部)
env命令只显示全局

$HOME   #用户家目录
$UID    #当前用户的UID
$PWD    #当前工作目录的绝对路径
$SHELL  #当前shell
$USER   #当前用户

环境变量初始化及生效顺序
永利平台娱乐 4

  • 登录系统,加载主环境变量文件/etc/profile
  • 执行/etc/profile.d目录下的脚本
  • 运行$HOME/.bash_profile用户环境变量文件
  • 在用户环境变量文件中会去找$HOME/.bashrc,如果有这个文件则执行,没有找/etc/bashrc全局环境变量文件

(2)普通变量(局部)
由字母、数字、下划线组成
可以用单引号或双引号引起来

[xiaoda@codis-178 ~]$ a=192.168.16.1
[xiaoda@codis-178 ~]$ b='192.168.16.1'
[xiaoda@codis-178 ~]$ c="192.168.16.1"
[xiaoda@codis-178 ~]$ echo "a=$a"
a=192.168.16.1
[xiaoda@codis-178 ~]$ echo "b=$b"
b=192.168.16.1
[xiaoda@codis-178 ~]$ echo "c=$c"
c=192.168.16.1
[xiaoda@codis-178 ~]$ echo "c=${c}"
c=192.168.16.1

[xiaoda@codis-178 ~]$ a=192.168.16.1-$a
[xiaoda@codis-178 ~]$ b='192.168.16.1-$a'
[xiaoda@codis-178 ~]$ c="192.168.16.1-$a"
[xiaoda@codis-178 ~]$ echo "a=$a"
a=192.168.16.1-192.168.16.1
[xiaoda@codis-178 ~]$ echo "b=$b"
b=192.168.16.1-$a
[xiaoda@codis-178 ~]$ echo "c=${c}"
c=192.168.16.1-192.168.16.1-192.168.16.1

把命令的结果作为变量的内容进行赋值

[xiaoda@codis-178 ~]$ CMD=$(date + %F)
date: extra operand `%F'
Try `date --help' for more information.
[xiaoda@codis-178 ~]$ CMD=$(date +%F)
[xiaoda@codis-178 ~]$ echo $CMD
2017-07-04
[xiaoda@codis-178 ~]$ echo $(date +%F).tar.gz
2017-07-04.tar.gz
[xiaoda@codis-178 ~]$ echo $(CMD).tar.gz
-bash: CMD: command not found
.tar.gz
[xiaoda@codis-178 ~]$ echo $CMD.tar.gz
2017-07-04.tar.gz
[xiaoda@codis-178 ~]$ echo ${CMD}.tar.gz
2017-07-04.tar.gz

        echo "MUST be root to run this script."

3.变量输出

单引号:内容原样输出,强引用
双引号:如果内容有命令、变量、转移符等,会解析出结果再输出,弱引用
反引号:引用命令

[xiaoda@codis-178 ~]$ echo 'today is date'
today is date
[xiaoda@codis-178 ~]$ echo 'today is `date`'
today is `date`
[xiaoda@codis-178 ~]$ echo "today is date"
today is date
[xiaoda@codis-178 ~]$ echo "today is `date`"
today is Tue Jul  4 15:34:38 CST 2017
[xiaoda@codis-178 ~]$ echo "today is $(date)"
today is Tue Jul  4 15:34:49 CST 2017

调用变量

[xiaoda@codis-178 ~]$ OLDBOY=testchars
[xiaoda@codis-178 ~]$ echo $OLDBOY
testchars
[xiaoda@codis-178 ~]$ echo '$OLDBOY'
$OLDBOY
[xiaoda@codis-178 ~]$ echo "$OLDBOY"
testchars

其他调用方式

[xiaoda@codis-178 ~]$ cat grep.log 
testchars
oldboy
[xiaoda@codis-178 ~]$ grep "$OLDBOY" grep.log 
testchars
[xiaoda@codis-178 ~]$ grep '$OLDBOY' grep.log 
[xiaoda@codis-178 ~]$ grep $OLDBOY grep.log 
testchars

[xiaoda@codis-178 ~]$ ETT=123

[xiaoda@codis-178 ~]$ awk 'BEGIN {print "$ETT"}'
$ETT
[xiaoda@codis-178 ~]$ awk 'BEGIN {print $ETT}'

[xiaoda@codis-178 ~]$ awk 'BEGIN {print '$ETT'}'
123
[xiaoda@codis-178 ~]$ awk 'BEGIN {print "'$ETT'"}'
123

永利平台娱乐 5

        exit 1

fi

cd $LOG_DIR || {

        echo "Cannot change to necessary directory"

        exit 1

}

cat /dev/null>messages && {

        echo "Logs cleaned up."

        exit 0

}

echo "Logs cleaned up fail."

exit 1

上面的脚本设计成了如下几关:

第一关:必须是root才能执行脚本,否则会给出友好提示并终止脚本运行

TAG标签:
版权声明:本文由永利平台娱乐发布于IT交流,转载请注明出处:多数情况下无区别,上面的脚本设计成了如下几